# Operators
PLUS = '+'
MINUS = '-'
MUL = '*'
DIV = '/'
FLOORDIV = '//'
MOD = '%'
POWER = '^'
ARITHMATIC_LEFT_SHIFT = '<<<'
ARITHMATIC_RIGHT_SHIFT = '>>>'
XOR = 'xor'
BINARY_ONES_COMPLIMENT = '~'
BINARY_LEFT_SHIFT = '<<'
BINARY_RIGHT_SHIFT = '>>'
AND = 'y_es'
OR = 'o_es'
NOT = 'no'
IN = 'en'  # TODO
NOT_IN = 'no en'  # TODO
IS = 'es'
IS_NOT = 'no es'
LPAREN = '('
RPAREN = ')'
LSQUAREBRACKET = '['
RSQUAREBRACKET = ']'
LCURLYBRACKET = '{'
RCURLYBRACKET = '}'
COMMA = ','
COLON = ':'
DOT = '.'
RANGE = '..'
ELLIPSIS = '...'  # TODO
ARROW = '->'
CAST = 'como'
ASSIGN = '='
PLUS_ASSIGN = '+='
MINUS_ASSIGN = '-='
MUL_ASSIGN = '*='
DIV_ASSIGN = '/='
FLOORDIV_ASSIGN = '//='
MOD_ASSIGN = '%='
POWER_ASSIGN = '^='
PLUS_PLUS = '++'
MINUS_MINUS = '--'
EQUALS = '=='
NOT_BANG = '!'
NOT_EQUALS = '!='
LESS_THAN = '<'
GREATER_THAN = '>'
LESS_THAN_OR_EQUAL_TO = '<='
GREATER_THAN_OR_EQUAL_TO = '>='
DECORATOR = '@'  # TODO

# Types
ANY = 'cualquiera'
INT = 'entero'
INT8 = 'entero8'
INT16 = 'entero16'
INT32 = 'entero32'
INT64 = 'entero64'  # same as int but doesn't automatically promote to larger integer type upon overflow
INT128 = 'entero128'
UINT = 'sin_signo'
UINT8 = 'sin_signo8'
UINT16 = 'sin_signo16'
UINT32 = 'sin_signo32'
UINT64 = 'sin_signo64'
UINT128 = 'sin_signo128'
DOUBLE = 'doble'
FLOAT = 'flotante'
COMPLEX = 'complejo'  # TODO
STR = 'cadena'
BOOL = 'booleano'
LIST = 'lista'
TUPLE = 'tupla'
SET = 'conjunto'  # TODO
DICT = 'dict'
ENUM = 'enum'
FUNC = 'func'
STRUCT = 'estructura'
CLASS = 'clase'

# Contstants
TRUE = 'VERDADERO'
FALSE = 'FALSO'
NULL = 'NULO'  # TODO
INF = 'INFINITO'

# Keywords
IF = 'si'
ELSE_IF = 'sino si'
ELSE = 'sino'
FOR = 'para'
WHILE = 'mientras'
SWITCH = 'segun_sea'
CASE = 'caso'
DEFAULT = 'defecto'
OPERATOR = 'operador'
EXTERN = 'externa'
DEF = 'def'
CONST = 'const'
SUPER = 'super'  # TODO
SELF = 'self'
RETURN = 'retorna'
TRY = 'intenta'  # TODO
CATCH = 'atrapa'  # TODO
THROW = 'tirar'  # TODO
FINALLY = 'finalmente'  # TODO
YIELD = 'yield'  # TODO
BREAK = 'salir'
FALLTHROUGH = 'fallthrough'
DEFER = 'diferir'
CONTINUE = 'continuar'
DEL = 'del'  # TODO
FROM = 'from'  # TODO
IMPORT = 'import'  # TODO
WILDCARD = '*'  # TODO
WITH = 'with'  # TODO
PASS = 'pasar'
VOID = 'vacío'
TYPE = 'tipo'
OVERRIDE = 'override'  # TODO
ABSTRACT = 'abstract'  # TODO
ASSERT = 'assert'  # TODO

ARITHMETIC_OP = (PLUS, MINUS, MUL, DIV, MOD, FLOORDIV, POWER, ARITHMATIC_LEFT_SHIFT, ARITHMATIC_RIGHT_SHIFT)

ASSIGNMENT_OP = (ASSIGN, PLUS_ASSIGN, MINUS_ASSIGN, MUL_ASSIGN, DIV_ASSIGN, FLOORDIV_ASSIGN, MOD_ASSIGN, POWER_ASSIGN, PLUS_PLUS, MINUS_MINUS)

ARITHMETIC_ASSIGNMENT_OP = (PLUS_ASSIGN, MINUS_ASSIGN, MUL_ASSIGN, DIV_ASSIGN, FLOORDIV_ASSIGN, MOD_ASSIGN, POWER_ASSIGN)

INCREMENTAL_ASSIGNMENT_OP = (PLUS_PLUS, MINUS_MINUS)

COMPARISON_OP = (EQUALS, NOT_BANG, NOT_EQUALS, LESS_THAN, GREATER_THAN, GREATER_THAN_OR_EQUAL_TO, LESS_THAN_OR_EQUAL_TO, IS, IS_NOT)

LOGICAL_OP = (AND, OR, NOT)

BINARY_OP = (XOR, BINARY_ONES_COMPLIMENT, BINARY_LEFT_SHIFT, BINARY_RIGHT_SHIFT)

MEMBERSHIP_OP = (IN, NOT_IN)

MULTI_WORD_OPERATORS = (IS, IS_NOT, IN, NOT_IN, NOT)

OPERATORS = (
    LPAREN, RPAREN, LSQUAREBRACKET, RSQUAREBRACKET, LCURLYBRACKET, RCURLYBRACKET,
    ARROW, COMMA, COLON, DOT, DECORATOR, CAST, RANGE, ELLIPSIS,
) + ARITHMETIC_OP + ASSIGNMENT_OP + COMPARISON_OP + LOGICAL_OP + BINARY_OP + MEMBERSHIP_OP

SINGLE_OPERATORS = (
    LPAREN, RPAREN, LSQUAREBRACKET, RSQUAREBRACKET, LCURLYBRACKET, RCURLYBRACKET,
    BINARY_ONES_COMPLIMENT, COMMA, DECORATOR
)

KEYWORDS = (
    IF, ELSE, WHILE, FOR, SWITCH, CASE, DEF, SUPER, RETURN, TRY, CATCH, THROW,
    FINALLY, YIELD, BREAK, CONTINUE, DEL, IMPORT, FROM, WITH, PASS, VOID,
    CONST, OVERRIDE, ABSTRACT, ASSERT, DEFAULT, TYPE, FALLTHROUGH,
    DEFER
)

MULTI_WORD_KEYWORDS = (IF, ELSE, ELSE_IF)

TYPES = (ANY, INT, INT8, INT16, INT32, INT64, INT128, UINT, UINT8, UINT16, UINT32, UINT64, UINT128, DOUBLE, FLOAT, COMPLEX, STR, BOOL, LIST, TUPLE, DICT, ENUM, FUNC, LIST, TUPLE, STRUCT, CLASS)

CONSTANTS = (TRUE, FALSE, NULL, INF)

PRINT = 'mostrar'
INPUT = 'leer'

BUILTIN_FUNCTIONS = (PRINT, INPUT)

# For Lexer
LTYPE = 'LTYPE'
NUMBER = 'NUMBER'
STRING = 'STRING'
OP = 'OP'
CONSTANT = 'CONSTANT'
NEWLINE = 'NEWLINE'
INDENT = 'INDENT'
KEYWORD = 'KEYWORD'
ANON = 'ANON'
NAME = 'NAME'
EOF = 'EOF'
ALPHANUMERIC = 'alphanumeric'
NUMERIC = 'numeric'
OPERATIC = 'operatic'
WHITESPACE = 'whitespace'
COMMENT = 'comment'
ESCAPE = 'escape'
